#ifndef IFPACK2_CONFIG_H
#define IFPACK2_CONFIG_H
/*
\file Ifpack2_config.h
\brief Macros stating Ifpack2's configuration options

\warning This file is automatically generated by CMake.  DO NOT EDIT
  THIS FILE.  CMake will overwrite this file.  The origin of this
  automatically generated file lives in Trilinos' source directory, in
  packages/ifpack2/cmake/Ifpack2_config.h.in.

\warning Users should NOT include this file directly.
  They should instead include Ifpack2_ConfigDefs.hpp.
*/

/*
 * Build options
 */

/* Define if we want to build Ifpack2 with debug support */
/* #undef HAVE_IFPACK2_DEBUG */

/* Define if explicit (template) instantiation is enabled. */
#define HAVE_IFPACK2_EXPLICIT_INSTANTIATION

/* Define if experimental Ifpack2 code is enabled. */
/* #undef HAVE_IFPACK2_EXPERIMENTAL */

/* Define if deprecated Ifpack2 code is enabled. */
/* #undef HAVE_IFPACK2_DEPRECATED_CODE */

/* Define if experimental Ifpack2 code that uses KokkosKernels is enabled. */
#define HAVE_IFPACK2_EXPERIMENTAL_KOKKOSKERNELS_FEATURES

// Backwards compatibility definition
#ifdef HAVE_IFPACK2_EXPERIMENTAL_KOKKOSKERNELS_FEATURES
#  define HAVE_IFPACK2_AND_TPETRAKERNELS_EXPERIMENTAL
#else
#  ifdef HAVE_IFPACK2_AND_TPETRAKERNELS_EXPERIMENTAL
#    undef HAVE_IFPACK2_AND_TPETRAKERNELS_EXPERIMENTAL
#  endif // HAVE_IFPACK2_AND_TPETRAKERNELS_EXPERIMENTAL
#endif // HAVE_IFPACK2_EXPERIMENTAL_KOKKOSKERNELS_FEATURES

/*Define to dump the input matrix for debug purposes*/
/* #undef HAVE_IFPACK2_DUMP_MTX_MATRIX */

/* Define if Ifpack2::SupportGraph is enabled. */
/* #undef HAVE_IFPACK2_SUPPORTGRAPH */

/* Enable timers in BlockTriDiContainer. */
/* #undef HAVE_IFPACK2_BLOCKTRIDICONTAINER_TIMERS */

/*
 * Package dependencies
 */

/* Define if we have Amesos2 */
#define HAVE_IFPACK2_AMESOS2

/* Define if we have Belos */
/* #undef HAVE_IFPACK2_BELOS */

/* Define if we have Galeri */
/* #undef HAVE_IFPACK2_GALERI */

/* Define if we have KokkosClassic */
/* #undef HAVE_IFPACK2_KOKKOSCLASSIC */

/* Define if we have ML */
#define HAVE_IFPACK2_ML

/* Define if we have ThyraTpetraAdapters */
#define HAVE_IFPACK2_THYRATPETRAADAPTERS

/* Define if we have Xpetra */
#define HAVE_IFPACK2_XPETRA

/* Define if we have Zoltan2 */
#define HAVE_IFPACK2_ZOLTAN2

/* Define if we have ShyLU/HTS */
#define HAVE_IFPACK2_SHYLU_NODEHTS

/*
 * TPL (third-party library) dependencies
 */

/* Define if building with the Cholmod library */
/* #undef HAVE_IFPACK2_CHOLMOD */

/* Define if building with the Lemon library */
/* #undef HAVE_IFPACK2_LEMON */

/* Define if building with MPI (the Message-Passing Interface) */
/* #undef HAVE_IFPACK2_MPI */

/* Define if we have the QD extended-precision TPL */
/* #undef HAVE_IFPACK2_QD */

/* Define if we have ShyLU FastILU (an inner preconditioner for Additive Schwarz) */
/* #undef HAVE_IFPACK2_SHYLU_NODEFASTILU */

/*
 * If deprecated warnings are on, and the compiler supports them, then
 * define IFPACK2_DEPRECATED to emit deprecated warnings.  Otherwise,
 * give it an empty definition.
 */
#ifndef IFPACK2_DEPRECATED
#  if (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 1))
#    define IFPACK2_DEPRECATED  __attribute__((__deprecated__))
#  else
#    define IFPACK2_DEPRECATED
#  endif
#endif

#ifndef IFPACK2_DEPRECATED_MSG
#  if (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 5))
#    define IFPACK2_DEPRECATED_MSG(MSG)  __attribute__((__deprecated__ (#MSG) ))
#  elif (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 1))
#    define IFPACK2_DEPRECATED_MSG(MSG)  __attribute__((__deprecated__))
#  else
#    define IFPACK2_DEPRECATED_MSG(MSG)
#  endif
#endif


#endif // IFPACK2_CONFIG_H
