# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/KokkosCore clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################


# Include guard
IF (KokkosCore_CONFIG_INCLUDED)
  RETURN()
ENDIF()
SET(KokkosCore_CONFIG_INCLUDED TRUE)

# Make sure CMAKE_CURRENT_LIST_DIR is usable
IF (NOT DEFINED CMAKE_CURRENT_LIST_DIR)
  GET_FILENAME_COMPONENT(_THIS_SCRIPT_PATH ${CMAKE_CURRENT_LIST_FILE} PATH)
  SET(CMAKE_CURRENT_LIST_DIR ${_THIS_SCRIPT_PATH})
ENDIF()


## ---------------------------------------------------------------------------
## Compilers used by Trilinos/KokkosCore build
## ---------------------------------------------------------------------------

SET(KokkosCore_CXX_COMPILER "/usr/bin/c++")

SET(KokkosCore_C_COMPILER "/usr/bin/cc")

SET(KokkosCore_FORTRAN_COMPILER "/usr/bin/gfortran")


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/KokkosCore build
## ---------------------------------------------------------------------------

## Give the build type
SET(KokkosCore_CMAKE_BUILD_TYPE "RelWithDebInfo")

## Set compiler flags, including those determined by build type
SET(KokkosCore_CXX_FLAGS "  -fmessage-length=0 -grecord-gcc-switches -O2 -Wall -D_FORTIFY_SOURCE=2 -fstack-protector-strong -funwind-tables -fasynchronous-unwind-tables -fstack-clash-protection -g -DNDEBUG -std=c++11 -fopenmp ")

SET(KokkosCore_C_FLAGS "  -fmessage-length=0 -grecord-gcc-switches -O2 -Wall -D_FORTIFY_SOURCE=2 -fstack-protector-strong -funwind-tables -fasynchronous-unwind-tables -fstack-clash-protection -g -DNDEBUG -fopenmp ")

SET(KokkosCore_FORTRAN_FLAGS " ")

## Extra link flags (e.g., specification of fortran libraries)
SET(KokkosCore_EXTRA_LD_FLAGS "-lgfortran")

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
SET(KokkosCore_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
SET(KokkosCore_BUILD_SHARED_LIBS "ON")

SET(KokkosCore_LINKER /usr/bin/ld)
SET(KokkosCore_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## List of package include dirs
SET(KokkosCore_INCLUDE_DIRS "${CMAKE_CURRENT_LIST_DIR}/../../../../include/trilinos")

## List of package library paths
SET(KokkosCore_LIBRARY_DIRS "${CMAKE_CURRENT_LIST_DIR}/../../../..//usr/lib64")

## List of package libraries
SET(KokkosCore_LIBRARIES "kokkoscore")

## Specification of directories for TPL headers
SET(KokkosCore_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
SET(KokkosCore_TPL_LIBRARY_DIRS "")

## List of required TPLs
SET(KokkosCore_TPL_LIBRARIES "/usr/lib64/libdl.so")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

SET(KokkosCore_MPI_LIBRARIES "")
SET(KokkosCore_MPI_LIBRARY_DIRS "")
SET(KokkosCore_MPI_INCLUDE_DIRS "")
SET(KokkosCore_MPI_EXEC "")
SET(KokkosCore_MPI_EXEC_MAX_NUMPROCS "")
SET(KokkosCore_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
SET(KokkosCore_PACKAGE_LIST "KokkosCore")

## The TPLs enabled for this project
SET(KokkosCore_TPL_LIST "DLlib;Pthread")


# Import KokkosCore targets
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/KokkosCoreTargets.cmake")
