# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/MueLu clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################


# Include guard
IF (MueLu_CONFIG_INCLUDED)
  RETURN()
ENDIF()
SET(MueLu_CONFIG_INCLUDED TRUE)

# Make sure CMAKE_CURRENT_LIST_DIR is usable
IF (NOT DEFINED CMAKE_CURRENT_LIST_DIR)
  GET_FILENAME_COMPONENT(_THIS_SCRIPT_PATH ${CMAKE_CURRENT_LIST_FILE} PATH)
  SET(CMAKE_CURRENT_LIST_DIR ${_THIS_SCRIPT_PATH})
ENDIF()


## ---------------------------------------------------------------------------
## Compilers used by Trilinos/MueLu build
## ---------------------------------------------------------------------------

SET(MueLu_CXX_COMPILER "/usr/bin/c++")

SET(MueLu_C_COMPILER "/usr/bin/cc")

SET(MueLu_FORTRAN_COMPILER "/usr/bin/gfortran")


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/MueLu build
## ---------------------------------------------------------------------------

## Give the build type
SET(MueLu_CMAKE_BUILD_TYPE "RelWithDebInfo")

## Set compiler flags, including those determined by build type
SET(MueLu_CXX_FLAGS "  -fmessage-length=0 -grecord-gcc-switches -O2 -Wall -D_FORTIFY_SOURCE=2 -fstack-protector-strong -funwind-tables -fasynchronous-unwind-tables -fstack-clash-protection -g -DNDEBUG -std=c++11 -fopenmp -Wno-unused-local-typedefs ")

SET(MueLu_C_FLAGS "  -fmessage-length=0 -grecord-gcc-switches -O2 -Wall -D_FORTIFY_SOURCE=2 -fstack-protector-strong -funwind-tables -fasynchronous-unwind-tables -fstack-clash-protection -g -DNDEBUG -fopenmp ")

SET(MueLu_FORTRAN_FLAGS " ")

## Extra link flags (e.g., specification of fortran libraries)
SET(MueLu_EXTRA_LD_FLAGS "-lgfortran")

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
SET(MueLu_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
SET(MueLu_BUILD_SHARED_LIBS "ON")

SET(MueLu_LINKER /usr/bin/ld)
SET(MueLu_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## List of package include dirs
SET(MueLu_INCLUDE_DIRS "${CMAKE_CURRENT_LIST_DIR}/../../../../include/trilinos")

## List of package library paths
SET(MueLu_LIBRARY_DIRS "${CMAKE_CURRENT_LIST_DIR}/../../../..//usr/lib64")

## List of package libraries
SET(MueLu_LIBRARIES "muelu-adapters;muelu-interface;muelu;intrepid2;stratimikos;stratimikosbelos;stratimikosamesos2;ifpack2-adapters;ifpack2;amesos2;shylu_nodetacho;shylu_nodehts;belosxpetra;belostpetra;belos;ml;zoltan2;galeri-xpetra;xpetra-sup;xpetra;thyratpetra;thyracore;trilinosss;tpetraext;tpetrainout;tpetra;kokkostsqr;tpetraclassiclinalg;tpetraclassicnodeapi;tpetraclassic;shards;zoltan;simpi;sacado;rtop;kokkoskernels;teuchoskokkoscomm;teuchoskokkoscompat;teuchosremainder;teuchosnumerics;teuchoscomm;teuchosparameterlist;teuchosparser;teuchoscore;kokkosalgorithms;kokkoscontainers;kokkoscore")

## Specification of directories for TPL headers
SET(MueLu_TPL_INCLUDE_DIRS "/usr/include;/usr/include")

## Specification of directories for TPL libraries
SET(MueLu_TPL_LIBRARY_DIRS "")

## List of required TPLs
SET(MueLu_TPL_LIBRARIES "/usr/lib64/libdl.so;/usr/lib64/libz.so;/usr/lib64/libopenblas.so;/usr/lib64/libopenblas.so")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

SET(MueLu_MPI_LIBRARIES "")
SET(MueLu_MPI_LIBRARY_DIRS "")
SET(MueLu_MPI_INCLUDE_DIRS "")
SET(MueLu_MPI_EXEC "")
SET(MueLu_MPI_EXEC_MAX_NUMPROCS "")
SET(MueLu_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
SET(MueLu_PACKAGE_LIST "MueLu;Intrepid2;Stratimikos;Ifpack2;Amesos2;ShyLU_NodeTacho;ShyLU_NodeHTS;Belos;ML;Zoltan2;Galeri;Xpetra;Thyra;ThyraTpetraAdapters;ThyraCore;TrilinosSS;Tpetra;TpetraCore;TpetraTSQR;TpetraClassic;Shards;Zoltan;Sacado;RTOp;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;Kokkos;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
SET(MueLu_TPL_LIST "DLlib;Zlib;Boost;LAPACK;BLAS;Pthread")


# Include configuration of dependent packages
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Intrepid2/Intrepid2Config.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Stratimikos/StratimikosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Ifpack2/Ifpack2Config.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Amesos2/Amesos2Config.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ShyLU_NodeTacho/ShyLU_NodeTachoConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ShyLU_NodeHTS/ShyLU_NodeHTSConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Belos/BelosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ML/MLConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Zoltan2/Zoltan2Config.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Galeri/GaleriConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Xpetra/XpetraConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Thyra/ThyraConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ThyraTpetraAdapters/ThyraTpetraAdaptersConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ThyraCore/ThyraCoreConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TrilinosSS/TrilinosSSConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TpetraCore/TpetraCoreConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TpetraTSQR/TpetraTSQRConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TpetraClassic/TpetraClassicConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Shards/ShardsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Zoltan/ZoltanConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Sacado/SacadoConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../RTOp/RTOpConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../KokkosKernels/KokkosKernelsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Teuchos/TeuchosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosKokkosComm/TeuchosKokkosCommConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosKokkosCompat/TeuchosKokkosCompatConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosRemainder/TeuchosRemainderConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosNumerics/TeuchosNumericsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosComm/TeuchosCommConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosParameterList/TeuchosParameterListConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosParser/TeuchosParserConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosCore/TeuchosCoreConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Kokkos/KokkosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../KokkosAlgorithms/KokkosAlgorithmsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../KokkosContainers/KokkosContainersConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../KokkosCore/KokkosCoreConfig.cmake")

# Import MueLu targets
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/MueLuTargets.cmake")
